'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./npm.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NumberInput = function (_Component) {
    _inherits(NumberInput, _Component);

    function NumberInput() {
        _classCallCheck(this, NumberInput);

        var _this = _possibleConstructorReturn(this, (NumberInput.__proto__ || Object.getPrototypeOf(NumberInput)).call(this));

        _this.state = {
            min: false, // 是否到了最小
            max: false // 是否到了最大
        };
        return _this;
    }

    _createClass(NumberInput, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.drawCanvas();
            this.inputChange();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            var _value = this.refs['number-input'].value;
            if (_value <= 1 || !_value) {
                this.setStatus('min');
                _value = 1;
            } else if (_value >= this.props.max) {
                this.setStatus('max');
                _value = this.props.max;
            } else this.setStatus('normal');
        }
    }, {
        key: 'drawCanvas',
        value: function drawCanvas() {
            var _minus = this.refs['number-input-minus'];
            var _ctx = _minus.getContext('2d');
            _ctx.strokeStyle = '#666';

            _ctx.beginPath();
            _ctx.moveTo(0, 5);
            _ctx.lineTo(10, 5);
            _ctx.lineWidth = 2;
            _ctx.stroke();

            var _plus = this.refs['number-input-plus'];
            _ctx = _plus.getContext('2d');
            _ctx.lineWidth = 2;

            _ctx.beginPath();
            _ctx.moveTo(0, 5);
            _ctx.lineTo(10, 5);
            _ctx.stroke();

            _ctx.beginPath();
            _ctx.moveTo(5, 0);
            _ctx.lineTo(5, 10);
            _ctx.stroke();
        }
    }, {
        key: 'inputChange',
        value: function inputChange() {
            var _value = this.refs['number-input'].value;
            _value = _value.replace(/\D/, '');
            _value = parseInt(_value);

            _value = this.checkValue(_value);

            this.refs['number-input'].value = _value;
        }
    }, {
        key: 'checkValue',
        value: function checkValue(value) {
            if (value <= 1 || !value) {
                this.setStatus('min');
                value = 1;
            } else if (value >= this.props.max) {
                this.setStatus('max');
                value = this.props.max;
            } else this.setStatus('normal');

            this.props.setValue(value); // 核查之后, 上层拿到数据

            return value;
        }
    }, {
        key: 'setStatus',
        value: function setStatus(type) {
            var _status = {
                max: false,
                min: false
            };
            switch (type) {
                case 'min':
                    _status.min = true;
                    break;
                case 'max':
                    _status.max = true;
                    break;
            }
            this.setState(_status);
        }
    }, {
        key: 'minusClick',
        value: function minusClick() {
            this.changeNumber(false);
        }
    }, {
        key: 'plusClick',
        value: function plusClick() {
            this.changeNumber(true);
        }
    }, {
        key: 'changeNumber',
        value: function changeNumber(isPlus) {
            var _numberInput = this.refs['number-input'];
            var _value = _numberInput.value;
            _value = parseInt(_value) + (isPlus ? 1 : -1);
            _value = this.checkValue(_value);
            _numberInput.value = _value;
            _numberInput.focus();
        }
    }, {
        key: 'keyDown',
        value: function keyDown(e) {
            var _keyCode = e.which || e.keyCode;
            if (_keyCode === 38) {
                this.changeNumber(true);
                e.preventDefault();
            } else if (_keyCode === 40) {
                this.changeNumber(false);
                e.preventDefault();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var _minusClassName = 'number-input-control number-input-minus';
            if (this.state.min) _minusClassName += ' halfOpacity';
            var _plusClassName = 'number-input-control number-input-plus';
            if (this.state.max) _plusClassName += ' halfOpacity';

            return _react2.default.createElement(
                'div',
                { className: 'number-input-box' },
                _react2.default.createElement(
                    'div',
                    { className: _minusClassName,
                        onClick: this.minusClick.bind(this) },
                    _react2.default.createElement('canvas', { ref: 'number-input-minus', width: 10, height: 10 })
                ),
                _react2.default.createElement('input', { ref: 'number-input', className: 'number-input', value: _props.value || _props.min || 1,
                    onChange: this.inputChange.bind(this),
                    onKeyDown: this.keyDown.bind(this) }),
                _react2.default.createElement(
                    'div',
                    { className: _plusClassName,
                        onClick: this.plusClick.bind(this) },
                    _react2.default.createElement('canvas', { ref: 'number-input-plus', width: 10, height: 10 })
                )
            );
        }
    }]);

    return NumberInput;
}(_react.Component);

exports.default = NumberInput;


NumberInput.propTypes = {
    max: _propTypes2.default.number.isRequired,
    setValue: _propTypes2.default.func.isRequired
};
